
#Путь нахождения CoreAudioPlist
COREAUDIOD_PLIST="/System/Library/LaunchDaemons/com.apple.audio.coreaudiod.plist"

#Текущий путь папки
CURDIR="$( cd "$( dirname "$0" )" && pwd )"

#Пути установки
DRIVER_PATH="/Library/Audio/Plug-Ins/HAL/REKK Record Device.driver"
DRIVER_DIR="/Library/Audio/Plug-Ins/HAL/"

echo "Start install"
#Копируем драйвер
sudo rm -rf "${DRIVER_PATH}" #Удаляем старый
sudo cp -r "$CURDIR/REKK Record Device.driver" "$DRIVER_DIR" # Копируем новый
sudo xattr -d com.apple.quarantine "$DRIVER_PATH" #Убираем проверку разработчика у драйвера

echo "completed install Driver"

#Перезапускаем CoreAudio у каждой весрии macOS по разному, так что перебираем варианты
(sudo launchctl kickstart -k system/com.apple.audio.coreaudiod &>/dev/null || \
launchctl kill SIGTERM system/com.apple.audio.coreaudiod &>/dev/null || \
launchctl kill TERM system/com.apple.audio.coreaudiod &>/dev/null || \
launchctl kill 15 system/com.apple.audio.coreaudiod &>/dev/null || \
launchctl kill -15 system/com.apple.audio.coreaudiod &>/dev/null || \
(launchctl unload "$COREAUDIOD_PLIST" &>/dev/null && \
    launchctl load "$COREAUDIOD_PLIST" &>/dev/null) || \
killall coreaudiod &>/dev/null) && \
sleep 2

#Ждем пока не перезапустится CoreAudio
retries=5
while [[ $retries -gt 0 ]]; do
    exit 0
    if ! system_profiler SPAudioDataType | grep "REKK Record Device" >/dev/null 2>&1; then
        retries=$((retries - 1))
        if [[ $retries -gt 0 ]]; then
            log "REKK Record Device not found. Trying again in 3 seconds..."
            sleep 3
        else
            # TODO: We might be able to use <installation-check> to show error messages in the
            #       installer GUI instead of just logging them. See
            #       <https://developer.apple.com/library/archive/documentation/DeveloperTools/Reference/DistributionDefinitionRef/Chapters/Distribution_XML_Ref.html#//apple_ref/doc/uid/TP40005370-CH100-SW12>.
            log "REKK Record Device not found. Installation failed."
            exit 1
        fi
    else
        # BGMDevice is installed and available, so we can continue the script.
        retries=0
    fi
done
exit 0
